#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int		 count[256];

int
char_sort(const int *i, const int *j)
{
	return count[*j] - count[*i];
}

int
main(int argc, char **argv)
{
	int		 off[256];
	FILE	*input;
	char	 line[BUFSIZ];
	char	*cp;
	int		 i;

	memset(count, 0, sizeof(count));

	if (argc != 2) {
		printf("Usage: %s <file>\n", argv[0]);
		return 1;
	}

	input = fopen(argv[1], "r");
	if (!input) {
		perror(argv[1]);
		return 2;
	}

	while (fgets(line, BUFSIZ, input))
		for (cp = line; *cp; cp++)
			count[*cp]++;

	fclose(input);
	count['\n'] = 0;

	for (i = 0; i < 256; i++)
		off[i] = i;

	qsort(off, 256, sizeof(i), char_sort);

	for (i = 0; i < 256; i++)
		if (count[off[i]])
			printf("%c %d\n", off[i], count[off[i]]);

	return 0;
}
