#ifndef __HASH_H__
#define __HASH_H__

#include "vector.h"

#define HASHINITSIZE	2503		// Prime number

typedef delete_t hash_delete_t;

typedef
struct _hash_value_t {
	char					*key;
	void					*data;
	struct _hash_value_t	*next;
} hash_value_t;

typedef
struct _hash_t {
	int						  size;
	hash_value_t			**data;
	hash_delete_t			  h_delete;
} hash_t;

hash_t		*hash_new(hash_delete_t func, int hashsize);
void		 hash_delete(hash_t *hash);
void		 hash_add(hash_t *hashtable, const char *key, void *data);
void		*hash_get(hash_t *hashtable, const char *key);
bool		 hash_remove(hash_t *h, char *key);
vector_t	*hash_keys(hash_t *hashtable);

#endif
