#ifndef __TAG_H__
#define __TAG_H__

#include "vector.h"
#include "hash.h"
#include "rope.h"

/* Have a 'singleton' flag? */

typedef
struct _element_t {
	int			 ttype;

/* For the four bytes, I'm not going to union these */
/* XXX There's a cheat in parser.y which relies on it not being a
 * union */

	/* Either */
	hash_t		*attr;
	vector_t	*elem;

	/* Or */
	rope_t		*cdata;
} element_t;

element_t	*element_new(char *word, void *data);
void		 element_delete(element_t *t);
int			 element_type(element_t *t);
void		 element_attr_set(element_t *t, char *key, rope_t *data);
rope_t		*element_attr_get(element_t *t, char *key);
void		 element_push_back(element_t *t, element_t *d);
int			 element_elem_length(element_t *t);
element_t	*element_elem_get(element_t *t, int off);
rope_t		*element_cdata(element_t *e);

#endif
